POJ3041 Asteroids

Asteroids

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 20458   Accepted: 11098

Description

Bessie wants to navigate her spaceship through a dangerous asteroid field in the shape of an N x N grid (1 <= N <= 500). The grid contains K asteroids (1 <= K <= 10,000), which are conveniently located at the lattice points of the grid.

Fortunately, Bessie has a powerful weapon that can vaporize all the asteroids in any given row or column of the grid with a single shot.This weapon is quite expensive, so she wishes to use it sparingly.Given the location of all the asteroids in the field, find the minimum number of shots Bessie needs to fire to eliminate all of the asteroids.

Input

* Line 1: Two integers N and K, separated by a single space. 
* Lines 2..K+1: Each line contains two space-separated integers R and C (1 <= R, C <= N) denoting the row and column coordinates of an asteroid, respectively.

Output

* Line 1: The integer representing the minimum number of times Bessie must shoot.

Sample Input

3 4
1 1
1 3
2 2
3 2

Sample Output

2

Hint

INPUT DETAILS: 
The following diagram represents the data, where "X" is an asteroid and "." is empty space: 
X.X 
.X. 
.X.

OUTPUT DETAILS: 
Bessie may fire across row 1 to destroy the asteroids at (1,1) and (1,3), and then she may fire down column 2 to destroy the asteroids at (2,2) and (3,2).

题目大意是,一个矩阵,某些位置有小行星,有一种炸弹,一次可以炸掉一行或者一列,现在问题是需要最少用多少这样的炸弹。

我们用匈牙利算法来求最大匹配

 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cstring>
 4 #include <algorithm>
 5 using namespace std;
 6
 7 const int maxn=505;
 8 const int maxm=10005;
 9 int N,K;
10 int Head[maxn],Adj[maxm],Next[maxm];
11 int match[maxn],use[maxn];
12 int c;
13
14 void AddEdge(int u,int v)
15 {
16     c++;
17     Adj[c]=v;
18     Next[c]=Head[u];
19     Head[u]=c;
20 }
21
22 bool dfs(int x)
23 {
24     for(int i=Head[x];i;i=Next[i])
25     {
26         int v=Adj[i]-N;
27         if(use[v]) continue;
28         use[v]=true;
29         if(match[v]==0||dfs(match[v]))
30         {
31             match[v]=x;
32             return true;
33         }
34     }
35     return false;
36 }
37
38 void hungarian(int &cnt)
39 {
40     for(int i=1;i<=N;i++)
41     {
42         memset(use,false,sizeof(use));
43         if(dfs(i)) cnt++;
44     }
45 }
46
47 int main()
48 {
49     freopen("poj3041.in","r",stdin);
50     freopen("poj3041.out","w",stdout);
51     scanf("%d %d",&N,&K);
52     int a,b;
53     for(int i=1;i<=K;i++)
54     {
55         scanf("%d %d",&a,&b);
56         AddEdge(a,b+N);
57     }
58     int cnt=0;
59     hungarian(cnt);
60     printf("%d",cnt);
61     return 0;
62 }

时间: 2024-08-28 09:04:41

POJ3041 Asteroids的相关文章

poj3041 Asteroids --- 最小点覆盖

#include<cstdio> #include<cstring> #include<cmath> #include<iostream> #include<algorithm> #include<vector> #include<queue> const int maxn=510; using namespace std; int my[maxn],mx[maxn],vis[maxn],e[maxn][maxn],n;

解题报告 之 POJ3041 Asteroids

解题报告 之 POJ3041 Asteroids Description Bessie wants to navigate her spaceship through a dangerous asteroid field in the shape of an N x N grid (1 <= N <= 500). The grid contains K asteroids (1 <= K <= 10,000), which are conveniently located at t

poj3041 Asteroids(二分图最小顶点覆盖、二分图匹配)

Description Bessie wants to navigate her spaceship through a dangerous asteroid field in the shape of an N x N grid (1 <= N <= 500). The grid contains K asteroids (1 <= K <= 10,000), which are conveniently located at the lattice points of the

POJ3041 Asteroids(二分图最小点覆盖)

Description Bessie wants to navigate her spaceship through a dangerous asteroid field in the shape of an N x N grid (1 <= N <= 500). The grid contains K asteroids (1 <= K <= 10,000), which are conveniently located at the lattice points of the

POJ3041 Asteroids【二分图最小点覆盖】

题目链接: http://poj.org/problem?id=3041 题目大意: 有一个N*N的矩阵,有些格子上有障碍物(坐标为(x,y) ),在消除这些障碍物的时候,可以一次性消除 该障碍物同一行所有的障碍物,或是一次性消除该障碍物同一列所有的障碍物.只能选择清理该行或是 清理该列.问:最小进行多少次消除,就可以清理所有的障碍物. 思路: 可以将每一行当做一个点,这样总共有N个点,作为二分图的一边.将每一列当做一个点,这样又有N 个点,作为二分图的另一边.将有障碍物的行点和列点连接起来,每

[POJ3041] Asteroids(最小点覆盖-匈牙利算法)

传送门 题意: 给一个N*N的矩阵,有些格子有障碍,要求我们消除这些障碍,问每次消除一行或一列的障碍,最少要几次. 解析: 把每一行与每一列当做二分图两边的点. 某格子有障碍,则对应行与列连边. 选出最少的点,使得所有边被覆盖. 最小点覆盖. ——代码 1 #include <cstdio> 2 #include <cstring> 3 #define M(x, a) memset(a, x, sizeof(a)) 4 5 using namespace std; 6 7 cons

POJ3041 Asteroids(匈牙利算法)

嘟嘟嘟 虽然我已经会网络流了,但是还是学了一个匈牙利算法. --就跟我会线段树,但还是学了树状数组一样. 其实匈牙利算法挺暴力的.简单来说就是先贪心匹配,然后如果左部点\(i\)匹配不上了,就尝试更改前面已经匹配好的点,腾出地给他匹配. 因此对于每一个点跑一遍匈牙利算法,如果这个点匹配成功,总匹配数就加1. 感觉没啥好讲的. 关于这道题怎么做,看我这篇博客吧. #include<cstdio> #include<iostream> #include<cmath> #in

poj图论解题报告索引

最短路径: poj1125 - Stockbroker Grapevine(多源最短路径,floyd) poj1502 - MPI Maelstrom(单源最短路径,dijkstra,bellman-ford,spfa) poj1511 - Invitation Cards(单源来回最短路径,spfa邻接表) poj1797 - Heavy Transportation(最大边,最短路变形,dijkstra,spfa,bellman-ford) poj2240 - Arbitrage(汇率问题,

图论专题整理

poj1251 Jungle Roads 思路:最小生成树          解题报告Here CodeForces 472D Design Tutorial: Inverse the Problem 思路:最小生成树          解题报告Here poj1789 Truck History 思路:最小生成树          解题报告Here poj1639 Picnic Planning 思路:顶点度数限制的MST         解题报告Here poj1062 昂贵的聘礼 思路:S